package org.jeecg.modules.orderplatform.util;

import cn.com.ctop.common.module.mapper.MailLogMapper;
import cn.com.ctop.common.module.utils.CorpWexinUtils;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.modules.orderplatform.service.IPlatformMaterialService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

@Slf4j
@Service
public class ApprovalNodeNoticeHandler {

    @Autowired
    MailLogMapper mailLogMapper;

    @Autowired
    IPlatformMaterialService platformMaterialService;

    /**
     * 审批节点发送
     */
    public void notice(String operate, Set<String> acceptor) {
        switch (operate) {
            //设计组长接单，暂时不通知
            case "ACCEPT_ORDER":
                sendWeChat(acceptor, "您发起的订单接单成功");
                break;
            //设计组长驳回订单，通知下单运营订单已被驳回
            case "REJECT_ORDER":
                sendWeChat(acceptor, "您有订单被驳回，请前往汇创平台处理");
                break;
            //脚本审批通过，通知剪辑上传视频
            case "ACCEPT_SCRIPT":
                sendWeChat(acceptor, "有物料需要您上传视频，请前往汇创平台处理");
                break;
            //脚本被驳回，通知编导重新上传脚本
            case "REJECT_SCRIPT":
                sendWeChat(acceptor, "您上传的脚本被驳回，请前往汇创平台处理");
                break;
            //视频通过暂不通知
            case "ACCEPT_VIDEO":
                sendWeChat(acceptor, "审批通过了视频，请前往汇创平台处理");
                break;
            //视频被驳回，通知剪辑重新上传视频
            case "REJECT_VIDEO":
                sendWeChat(acceptor, "您上传的视频被驳回，请前往汇创平台处理");
                break;
            //运营下单，通知设计组长接单派单
            case "PAYOUT":
                sendWeChat(acceptor, "有一个订单需要您审批，请前往汇创平台处理");
                break;
            //设计上传脚本，通知运营审核
            case "SCRIPT":
                sendWeChat(acceptor, "有一个脚本需要您审批，请前往汇创平台处理");
                break;
            //设计上传视频，通知运营审核
            case "VIDEO":
                sendWeChat(acceptor, "有一个视频需要您审批，请前往汇创平台处理");
                break;
        }
    }

    /**
     *  查询消息接收者
     */
    private Map<String, Map<String,String>> relatePerson(String orderCode,String materialCode){
        Map<String,Map<String,String>> result= new HashMap<>();
        if(materialCode.isEmpty()){

        }else {

        }
        return result;
    }
    /**
     *  发送通知消息到企业微信
     */
    private void sendWeChat(Set<String> users, String message) {
        users.forEach(userId->{
            String weChatId = mailLogMapper.getWChatIdByUserId(userId);
            if (weChatId.isEmpty()) {
                log.error(String.format("User WeChat not found. userId =%s", userId));
                //TODO 通知管理员添加邮箱
            } else {
                CorpWexinUtils.sendMessageByWeChatId(weChatId, message);
            }
        });
    }
}
